From d52d7e79d3e989c39c86c9cdc5c4570a2c680ea5 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 06 2015 21:23:05 +0000
Subject: [PATCH 136/254] Start an association table for hubs/users.


---

diff --git a/hubs/models.py b/hubs/models.py
index 0768e92..40fbb0b 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -85,6 +85,24 @@ def init(db_url, debug=False, create=False):
     return scoped_session(sessionmaker(bind=engine))
 
 
+roles = ['subscriber', 'member', 'owner']
+
+
+class Association(BASE):
+    __tablename__ = 'association'
+
+    hub_id = sa.Column(sa.String(50),
+                       sa.ForeignKey('hubs.name'),
+                       primary_key=True)
+    user_id = sa.Column(sa.Text,
+                        sa.ForeignKey('users.openid'),
+                        primary_key=True)
+    role = sa.Column(sa.Enum(*roles), nullable=False)
+
+    user = relation("User", backref="associations")
+    hub = relation("Hub", backref="associations")
+
+
 class Hub(BASE):
     __tablename__ = 'hubs'
     name = sa.Column(sa.String(50), primary_key=True)
@@ -104,6 +122,14 @@ class Hub(BASE):
     members = ['ralph', 'sadin', 'sayan'] + owners
     subscribers = []
 
+
+    def subscribe(self, session, user):
+        # TODO -- add logic here to manage not adding the user multiple
+        # times, doing different roles, etc.. publish a fedmsg message,
+        # etc...
+        session.add(Association(user=user, hub=self, role='subscriber'))
+        session.commit()
+
     @classmethod
     def by_name(cls, session, name):
         return session.query(cls).filter_by(name=name).first()
@@ -245,5 +271,10 @@ class User(BASE):
             session.add(self)
             if not Hub.by_name(session, self.username):
                 Hub.create_user_hub(session, self.username, self.fullname)
+
+            # Subscribe self to some default hubs for now..
+            hub = Hub.by_name(session, 'designteam')
+            hub.subscribe(session, self)
+
             session.commit()
         return self
diff --git a/populate.py b/populate.py
index 0742abc..d8efe61 100755
--- a/populate.py
+++ b/populate.py
@@ -10,6 +10,7 @@ fedmsg_config = fedmsg.config.load_config()
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
 
+############## Infra team
 hub = hubs.models.Hub(name='designteam', summary='The Fedora Design Team')
 session.add(hub)
 
@@ -39,5 +40,35 @@ hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
 hub.widgets.append(widget)
 
-session.commit()
 
+############## Infra team
+hub = hubs.models.Hub(name='infrastructure', summary='The Fedora Infrastructure Team')
+session.add(hub)
+
+widget = hubs.models.Widget(plugin='stats', index=0)
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='rules', index=1,
+                            _config=json.dumps({
+                                'link': 'http://threebean.org'
+                            }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(plugin='dummy', index=2)
+hub.widgets.append(widget)
+
+# Added a hubs about widget
+widget = hubs.models.Widget(plugin='about', index=3,
+                            _config=json.dumps({
+                                "text": "I'm a Fedora user, and this is my about widget text!",
+                            }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
+                            _config=json.dumps({
+                                'text': 'This is a sticky note.',
+                            }))
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
+hub.widgets.append(widget)
+
+session.commit()

